/* This file is part of SWIS
   Copyright (C) 2007 Sergey Poznyakoff
 
   SWIS is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   SWIS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with SWIS.  If not, see <http://www.gnu.org/licenses/>. */

#include <config.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <locale.h>
#include "error.h"
#include "progname.h"
#include "xalloc.h"
#include "version-etc.h"

#define obstack_chunk_alloc malloc
#define obstack_chunk_free free
#include "obstack.h"

#define PACKAGE_AUTHOR "Sergey Poznyakoff"

void swis_version (FILE *fp, const char *progname);
void read_names_from_file (const char *filename);
void update_argcv (int *pargc, char ***pargv);
extern int filename_terminator;

int utf8_mbtowc_internal (void *data, int (*read) (void*), unsigned int *pwc);
int utf8_mbtowc (unsigned int *pwc, unsigned char *r, size_t len);
int utf8_wctomb (unsigned char *r, unsigned int wc);
unsigned utf8_toupper (unsigned wc);
int utf8_str_toupper (char *s, size_t len);
unsigned utf8_tolower (unsigned wc);
int utf8_str_tolower (char *s, size_t len);
size_t utf8_strlen (const char *s);

size_t mbutf8_strlen (const unsigned *s);
unsigned *mbutf8_strdup (const unsigned *s);
size_t mbutf8_hash_string (const unsigned *ws, size_t n_buckets);
int mbutf8_strcmp (const unsigned *a, const unsigned *b);

const unsigned *fget_word (FILE *fp,
			   int (*ignore) (void *data, FILE *fp, int c),
			   void *data);


void read_badwords (char *name);
int badword_p (const unsigned *s);
void register_exclude_regexp (const char *str);
void read_exclude_regexps (const char *filename);
int excluded_word_p (const char *word);

